Summary: BMS C library
Name: libbms
Version: 1.1.7
Release: 1%{dist}
License: Commercial
Group: System Environment/Libraries
Source: file:/linux/libbms-%{version}.src.tar.gz
BuildRoot: /var/tmp/%{name}-root
Provides: libbms.a libfs.a libfsp.a libjls.a
BuildRequires: ncurses-devel

%description
A library of general functions used by BMS programs.  Some continue to
be useful.  Others are not so useful, but needed to keep old programs
working.

%package devel
Summary: Headers and static library for libbms
Group: Development/Libraries

%description devel
Headers and static library for compiling programs that use libbms.

%prep
%setup -q

%build
make CFLAGS="$RPM_OPT_FLAGS -fPIC -I." RANLIB=ranlib
make -C jls CFLAGS="$RPM_OPT_FLAGS -fPIC -I. -I.." RANLIB=ranlib
make -C fsp CFLAGS="$RPM_OPT_FLAGS -fPIC -I. -I.." RANLIB=ranlib LIB=.. \
	LDFLAGS=-L.. lib img sm
make -C fs LIB=../ lib \
	CFLAGS="$RPM_OPT_FLAGS -fPIC -I. -I.. -I../fsp -I../jls" RANLIB=ranlib
make -C fsget LIB=../lib RANLIB=ranlib	\
	CFLAGS="$RPM_OPT_FLAGS -fPIC -I. -I.. -I../fs -I../fsp -I../jls"
%ifos aix4.1
CFLAGS="$RPM_OPT_FLAGS -I." RANLIB=ranlib make obstack vscanf
ln libbms.a PIClibbms.a
%else
#make CFLAGS="$RPM_OPT_FLAGS -I. -fPIC" M=PIC RANLIB=ranlib
ln libbms.a PIClibbms.a
%endif
mkdir pic
cd pic
ar xv ../PIClibbms.a
cd ..
gcc -shared -o libbms.so pic/*.o

%install
umask 002
mkdir -p $RPM_BUILD_ROOT/bms/sm
mkdir -p $RPM_BUILD_ROOT/bms/bin
mkdir -p $RPM_BUILD_ROOT/bms/lib
mkdir -p $RPM_BUILD_ROOT/bms/include
cp -p *.h fs/*.h $RPM_BUILD_ROOT/bms/include
cp -p fsp/*.h $RPM_BUILD_ROOT/bms/include
cp fsp/sm fsp/img $RPM_BUILD_ROOT/bms/bin
strip $RPM_BUILD_ROOT/bms/bin/*
%ifos aix4.1
mkdir -p $RPM_BUILD_ROOT/bms/slib
cp libbms.a $RPM_BUILD_ROOT/bms/slib
cp jls/libjls.a $RPM_BUILD_ROOT/bms/slib
cp libfs.a $RPM_BUILD_ROOT/bms/slib
cp libfsp.a $RPM_BUILD_ROOT/bms/slib
#cp libbms.so $RPM_BUILD_ROOT/bms/lib/libbms.a
ln libbms.so bms.so	# stay compat with existing programs
ar rv $RPM_BUILD_ROOT/bms/lib/libbms.a bms.so
# always use static lib for jls, fs, fsp
ln $RPM_BUILD_ROOT/bms/slib/libjls.a $RPM_BUILD_ROOT/bms/lib
ln $RPM_BUILD_ROOT/bms/slib/libfs.a $RPM_BUILD_ROOT/bms/lib
ln $RPM_BUILD_ROOT/bms/slib/libfsp.a $RPM_BUILD_ROOT/bms/lib
%else
cp libbms.a $RPM_BUILD_ROOT/bms/lib
cp libbms.so $RPM_BUILD_ROOT/bms/lib
cp jls/libjls.a $RPM_BUILD_ROOT/bms/lib
cp libfs.a $RPM_BUILD_ROOT/bms/lib
cp libfsp.a $RPM_BUILD_ROOT/bms/lib
%endif

# FIXME: include /bms/terminfo and /bms/bin/terminfo
#	 How to handle for both AIX and linux?

# FIXME: include /etc/profile.d/libbms to set BMS,SM,MONEY etc env vars

%clean
rm -rf $RPM_BUILD_ROOT

%ifos linux
%post
if grep '^/bms/lib$' /etc/ld.so.conf >/dev/null; then
  :
else
  echo "/bms/lib" >>/etc/ld.so.conf
fi
/sbin/ldconfig
%endif

%files
%defattr(-,root,bms)
%dir /bms/lib
%dir /bms/sm
%ifos aix4.1
/bms/lib/libbms.a
%else
/bms/lib/libbms.so
%endif
/bms/bin/sm
/bms/bin/img

%files devel
%defattr(-,root,bms)
%dir /bms/lib
%ifos aix4.1
%dir /bms/slib
/bms/slib/libbms.a
/bms/slib/libjls.a
/bms/slib/libfs.a
/bms/slib/libfsp.a
%else
/bms/lib/libbms.a
%endif
/bms/lib/libjls.a
/bms/lib/libfs.a
/bms/lib/libfsp.a
%dir /bms/include
/bms/include/*.h

%changelog
* Tue Feb 28 2012 Stuart Gathman <stuart@bmsi.com>	1.1.7-1
- Support 48-bit millisecond timestamp
- Use absolute path for /bms/bin/perror to avoid conflict with mysql perror
* Mon Nov 29 2004 Stuart Gathman <stuart@bmsi.com>	1.1.6-1
- make EBCDIC tables more like edx
* Mon Oct 06 2003 Stuart Gathman <stuart@bmsi.com>	1.1.5-3
- fix AIX specific isNAN to use ANSI isnan when available
- add vscanf and friends for AIX
* Fri May 23 2003 Stuart Gathman <stuart@bmsi.com>
- include img utility
* Wed Mar 05 2003 Stuart Gathman <stuart@bmsi.com>
- add libfsp
* Tue Dec 11 2001 Stuart Gathman <stuart@bmsi.com>
- add missing headers
* Tue Nov 06 2001 Stuart Gathman <stuart@bmsi.com>
- add libfs (static only)
* Wed Oct 17 2001 Stuart Gathman <stuart@bmsi.com>
- add libjls (static only)
* Tue Oct 16 2001 Stuart Gathman <stuart@bmsi.com>
- distribute shared lib in compat format for AIX
- include obstack for AIX
* Tue Jul 11 2000 Stuart Gathman <stuart@bmsi.com>
- nap function, .so and .a libs swapped
* Wed May 10 2000 Stuart Gathman <stuart@bmsi.com>
- first release
